import * as i0 from '@angular/core';
import { Injectable, Component, Inject, Input, NgModule } from '@angular/core';
import * as i5 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i1 from '@angular/common/http';
import { HttpHeaders, HttpClientModule } from '@angular/common/http';
import * as i1$1 from '@angular/forms';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as Highcharts from 'highcharts';
import Exporting from 'highcharts/modules/exporting';
import Highcharts3D from 'highcharts/highcharts-3d';
import * as i3 from '@angular/material/dialog';
import { MAT_DIALOG_DATA, MatDialogModule } from '@angular/material/dialog';
import { throwError } from 'rxjs';
import { catchError } from 'rxjs/operators';
import * as i4 from '@angular/material/snack-bar';
import * as i6 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i7 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i8 from '@angular/material/select';
import { MatSelectModule } from '@angular/material/select';
import * as i9 from '@angular/material/core';
import * as i10 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i11 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import * as i12 from '@angular/cdk/drag-drop';
import { DragDropModule } from '@angular/cdk/drag-drop';
import * as i13 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import { Chart, registerables } from 'chart.js';
import ChartDataLabels from 'chartjs-plugin-datalabels';
import { MatTooltipModule } from '@angular/material/tooltip';

class CustomComponentLibraryService {
    constructor() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: CustomComponentLibraryService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: CustomComponentLibraryService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: CustomComponentLibraryService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [] });

class CustomComponentLibraryComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: CustomComponentLibraryComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.5", type: CustomComponentLibraryComponent, selector: "lib-custom-component-library", ngImport: i0, template: `
    <p>
      custom-component-library works!
    </p>
  `, isInline: true, styles: [""] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: CustomComponentLibraryComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-custom-component-library', template: `
    <p>
      custom-component-library works!
    </p>
  ` }]
        }] });

const environment = {
    production: false,
    apiUrl: 'https://component-library-development-bff.meltwater.io/ccl',
    // apiUrl: 'http://localhost:3000',
};

class AirlineSentimentService {
    constructor(http) {
        this.http = http;
        this.apiUrl = environment.apiUrl;
        this.accessToken = null;
    }
    // access token to be used in the Authorization header
    setAccessToken(token) {
        this.accessToken = token;
    }
    // HTTP headers with the Authorization token
    getHeaders() {
        if (!this.accessToken) {
            throw new Error('Access token is not set');
        }
        return new HttpHeaders({
            Authorization: `Bearer ${this.accessToken}`,
        });
    }
    // error handling for GET requests
    handleError(error) {
        console.error('An error occurred:', error);
        // error message based on status code; else returning a default message
        const errorMessage = error.error?.message || 'An unexpected error occurred. Please try again later.';
        // returning an observable that throws an error
        return throwError(() => new Error(errorMessage));
    }
    getAirlineSentiment() {
        return this.http
            .get(`${this.apiUrl}/airline-tweets`, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    getDemo1Sentiment() {
        return this.http
            .get(`${this.apiUrl}/demo-1`, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    getDemo2Sentiment() {
        return this.http
            .get(`${this.apiUrl}/demo-2`, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    getNewsSentiment() {
        return this.http
            .get(`${this.apiUrl}/news`, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    getAppleSentiment() {
        return this.http
            .get(`${this.apiUrl}/apple`, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    getFastrackSentiment() {
        return this.http
            .get(`${this.apiUrl}/fastrack`, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    getSampleQuidditySentiment() {
        return this.http
            .get(`${this.apiUrl}/sample-quiddity-data`, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    getFinanceSentiment() {
        return this.http
            .get(`${this.apiUrl}/finance`, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    getImdbSentiment() {
        return this.http
            .get(`${this.apiUrl}/imdb`, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    getIphoneSentiment() {
        return this.http
            .get(`${this.apiUrl}/iphone16`, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    getParalympicsSentiment() {
        return this.http
            .get(`${this.apiUrl}/paralympics`, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    // POST request to save chart configurations
    saveChart(config) {
        return this.http
            .post(`${this.apiUrl}/saveChart`, config, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    // GET request to fetch chart by ID
    getChart(id) {
        return this.http
            .get(`${this.apiUrl}/getChart/${id}`, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    // PUT request to update the chart using its ID
    updateChart(id, config) {
        return this.http
            .put(`${this.apiUrl}/updateChart/${id}`, config, {
            headers: this.getHeaders(),
        })
            .pipe(catchError(this.handleError));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: AirlineSentimentService, deps: [{ token: i1.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: AirlineSentimentService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: AirlineSentimentService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: i1.HttpClient }] });

class ModifyChartDialogComponent {
    constructor(fb, sentimentService, dialogRef, chartId, snackBar // Inject MatSnackBar
    ) {
        this.fb = fb;
        this.sentimentService = sentimentService;
        this.dialogRef = dialogRef;
        this.chartId = chartId;
        this.snackBar = snackBar;
        this.showNotification = true;
        this.easingOptions = [
            'linear',
            'easeInBounce',
            'easeOutBounce',
            'easeInOutBounce',
            'easeInElastic',
            'easeOutElastic',
            'easeInOutElastic',
            'easeInQuad',
            'easeOutQuad',
            'easeInOutQuad',
            'easeInCubic',
            'easeOutCubic',
            'easeInOutCubic',
            'easeInQuart',
            'easeOutQuart',
            'easeInOutQuart',
            'easeInQuint',
            'easeOutQuint',
            'easeInOutQuint',
            'easeInSine',
            'easeOutSine',
            'easeInOutSine',
            'easeInExpo',
            'easeOutExpo',
            'easeInOutExpo',
            'easeInCirc',
            'easeOutCirc',
            'easeInOutCirc',
        ];
    }
    ngOnInit() {
        this.initializeForm();
        // Set notification to disappear after 4 seconds
        setTimeout(() => (this.showNotification = false), 4000);
        if (this.chartId) {
            this.loadChartConfig();
        }
        // Handling transparent background changes
        this.chartConfigForm.get('transparentBackground')?.valueChanges.subscribe((isTransparent) => {
            if (isTransparent) {
                // Set background color to 'transparent' when checkbox is checked
                this.chartConfigForm.get('backgroundColor')?.setValue('transparent');
            }
            else {
                // Resetting the background color to a default value if unchecked
                const currentColor = this.chartConfigForm.get('backgroundColor')?.value;
                if (!currentColor || currentColor === 'transparent') {
                    this.chartConfigForm.get('backgroundColor')?.setValue('#ffffff'); // Default color
                }
            }
        });
    }
    closeNotification() {
        this.showNotification = false;
    }
    // Initializing form with required controls and validation
    initializeForm() {
        this.chartConfigForm = this.fb.group({
            chartLibrary: [''],
            chartType: [''],
            title: [''],
            titleColor: [''],
            borderWidth: [''],
            borderColor: [''],
            rotation: [''],
            pieDataLabelsEnabled: [''],
            barDataLabelsEnabled: [''],
            dataLabelColor: [''],
            barDataLabelColor: [''],
            enable3D: [''],
            showInLegend: [''],
            legendPosition: [''],
            xAxisTitle: [''],
            yAxisTitle: [''],
            innerRadius: [''],
            orientation: [''],
            animationDuration: [''],
            animationEasing: [''],
            transparentBackground: [''],
            backgroundColor: [''],
        });
    }
    // Loading the existing chart configurations
    loadChartConfig() {
        this.sentimentService.getChart(this.chartId).subscribe((config) => {
            if (config) {
                this.existingConfig = config; // Storing existing configs
                this.chartConfigForm.patchValue({
                    chartLibrary: config.chartLibrary,
                    chartType: config.chartType,
                    title: config.title,
                    titleColor: config.titleColor,
                    borderWidth: config.borderWidth,
                    borderColor: config.borderColor,
                    rotation: config.rotation,
                    pieDataLabelsEnabled: config.pieDataLabelsEnabled,
                    barDataLabelsEnabled: config.barDataLabelsEnabled,
                    dataLabelColor: config.dataLabelColor,
                    barDataLabelColor: config.barDataLabelColor,
                    enable3D: config.enable3D,
                    showInLegend: config.showInLegend,
                    legendPosition: config.legendPosition,
                    xAxisTitle: config.xAxisTitle,
                    yAxisTitle: config.yAxisTitle,
                    innerRadius: config.innerRadius,
                    orientation: config.orientation,
                    animationDuration: config.animationDuration,
                    animationEasing: config.animationEasing,
                    transparentBackground: config.transparentBackground,
                    backgroundColor: config.backgroundColor,
                });
            }
        }, (error) => {
            console.error('Error loading chart configuration:', error);
        });
    }
    onSaveChart() {
        console.log('Save button clicked');
        if (this.chartConfigForm.valid) {
            const updatedConfig = {
                ...this.existingConfig, // Starting with existing config
                ...this.chartConfigForm.value, // Overwriting with new values from form
            };
            console.log('Form is valid, saving:', updatedConfig);
            this.sentimentService.updateChart(this.chartId, updatedConfig).subscribe(() => {
                console.log('Chart customizations saved successfully');
                this.snackBar.open('Customizations saved successfully. Please refresh the page!', 'OK', {
                    duration: 3000,
                    horizontalPosition: 'center',
                    verticalPosition: 'top',
                });
                this.dialogRef.close(updatedConfig);
            }, (error) => {
                console.error('Error while saving chart customizations:', error);
                this.snackBar.open('Error saving chart customizations. Please try again.', 'OK', {
                    duration: 3000,
                    horizontalPosition: 'center',
                    verticalPosition: 'top',
                });
            });
        }
        else {
            console.log('Form is invalid:', this.chartConfigForm.errors);
            Object.keys(this.chartConfigForm.controls).forEach((key) => {
                const controlErrors = this.chartConfigForm.get(key)?.errors;
                if (controlErrors) {
                    console.log(`Field: ${key}, Errors:`, controlErrors);
                }
            });
            this.snackBar.open('Please enter all the chart configurations correctly.', 'OK', {
                duration: 3000,
                horizontalPosition: 'center',
                verticalPosition: 'top',
            });
        }
    }
    onCancel() {
        this.dialogRef.close();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: ModifyChartDialogComponent, deps: [{ token: i1$1.FormBuilder }, { token: AirlineSentimentService }, { token: i3.MatDialogRef }, { token: MAT_DIALOG_DATA }, { token: i4.MatSnackBar }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.5", type: ModifyChartDialogComponent, selector: "lib-modify-chart-dialog", ngImport: i0, template: "<div cdkDrag cdkDragRootElement=\".cdk-overlay-pane\">\n    <div class=\"notification-banner\" *ngIf=\"showNotification\">\n        <p>You can move this dialog box by dragging it around!</p>\n        <button mat-icon-button (click)=\"closeNotification()\">\n            <mat-icon>close</mat-icon>\n        </button>\n    </div>\n    <h1 mat-dialog-title class=\"dialog-title\">Modify Chart: {{ chartConfigForm.get('title')?.value || 'Untitled' }}</h1>\n\n    <form [formGroup]=\"chartConfigForm\" (ngSubmit)=\"onSaveChart()\">\n        <div mat-dialog-content>\n            <div class=\"chart-id\">\n                <!-- Chart ID Field -->\n                <mat-form-field appearance=\"outline\" class=\"full-width\">\n                    <mat-label>Chart ID</mat-label>\n                    <input matInput [value]=\"chartId\" readonly />\n                </mat-form-field>\n            </div>\n\n            <div class=\"chart-configs\">\n                <!-- Chart Library Dropdown -->\n                <mat-form-field appearance=\"outline\" class=\"chart-library\">\n                    <mat-label>Chart Library</mat-label>\n                    <mat-select formControlName=\"chartLibrary\">\n                        <mat-option value=\"highcharts\">Highcharts</mat-option>\n                        <mat-option value=\"chartjs\">Chart.js</mat-option>\n                    </mat-select>\n                </mat-form-field>\n\n                <!-- Chart Type Dropdown -->\n                <mat-form-field appearance=\"outline\" class=\"chart-type\">\n                    <mat-label>Chart Type</mat-label>\n                    <mat-select formControlName=\"chartType\">\n                        <mat-option value=\"pie\">Pie</mat-option>\n                        <mat-option value=\"bar\">Bar</mat-option>\n                    </mat-select>\n                </mat-form-field>\n            </div>\n\n            <div class=\"title-configs\">\n                <!-- Chart Title -->\n                <mat-form-field appearance=\"outline\" class=\"title\">\n                    <mat-label>Chart Title</mat-label>\n                    <input matInput formControlName=\"title\" />\n                </mat-form-field>\n\n                <!-- Title Color -->\n                <mat-form-field appearance=\"outline\" class=\"title-color\">\n                    <mat-label>Title Color</mat-label>\n                    <input matInput type=\"color\" formControlName=\"titleColor\" />\n                </mat-form-field>\n            </div>\n\n            <div class=\"border-configs\">\n                <!-- Border thickness-->\n                <mat-form-field appearance=\"outline\" class=\"border-thickness\">\n                    <mat-label>Border Thickness</mat-label>\n                    <input matInput type=\"number\" formControlName=\"borderWidth\" />\n                </mat-form-field>\n\n                <!-- Border Color  -->\n                <mat-form-field appearance=\"outline\" class=\"border-color\">\n                    <mat-label>Border Color</mat-label>\n                    <input matInput type=\"color\" formControlName=\"borderColor\" />\n                </mat-form-field>\n            </div>\n\n            <div class=\"rotation-3dchart\">\n                <!-- Chart rotation  -->\n                <mat-form-field appearance=\"outline\" class=\"pie-chart-rotation\" *ngIf=\"chartConfigForm.get('chartType')?.value === 'pie'\">\n                    <mat-label>Rotation (degrees)</mat-label>\n                    <input matInput type=\"number\" min=\"0\" max=\"360\" formControlName=\"rotation\" />\n                </mat-form-field>\n\n                <mat-form-field appearance=\"outline\" *ngIf=\"chartConfigForm.get('chartType')?.value === 'pie'\" class=\"inner-radius\">\n                    <mat-label>Inner Radius</mat-label>\n                    <input matInput type=\"number\" formControlName=\"innerRadius\" />\n                </mat-form-field>\n\n                <!-- 3D charts for Highcharts library -->\n                <mat-checkbox formControlName=\"enable3D\" class=\"highcharts-3d\" *ngIf=\"chartConfigForm.get('chartLibrary')?.value === 'highcharts'\">\n                    Enable 3D\n                </mat-checkbox>\n            </div>\n\n            <div class=\"orientation-transparentbg\">\n                <mat-form-field appearance=\"outline\" *ngIf=\"chartConfigForm.get('chartType')?.value === 'bar'\" class=\"orientation\">\n                    <mat-label>Orientation</mat-label>\n                    <mat-select id=\"orientation\" formControlName=\"orientation\">\n                        <mat-option value=\"vertical\"> Vertical </mat-option>\n                        <mat-option value=\"horizontal\"> Horizontal </mat-option>\n                    </mat-select>\n                </mat-form-field>\n\n                <mat-checkbox formControlName=\"transparentBackground\" class=\"transparent-bg\"> Transparent Chart Background </mat-checkbox>\n\n                <mat-form-field appearance=\"outline\" class=\"bgcolor\" *ngIf=\"!chartConfigForm.get('transparentBackground')?.value\">\n                    <mat-label>Chart Background Color</mat-label>\n                    <input matInput type=\"color\" formControlName=\"backgroundColor\" />\n                </mat-form-field>\n            </div>\n\n            <div class=\"labels-legends-config\">\n                <!-- Enabling data labels for Pie charts-->\n                <mat-checkbox\n                    formControlName=\"pieDataLabelsEnabled\"\n                    *ngIf=\"chartConfigForm.get('chartType')?.value === 'pie'\"\n                    class=\"data-labels-checkbox\"\n                >\n                    Enable Data Labels\n                </mat-checkbox>\n\n                <!-- Data Label Color for Pie charts-->\n                <mat-form-field\n                    appearance=\"outline\"\n                    class=\"data-labels-color\"\n                    *ngIf=\"chartConfigForm.get('chartType')?.value === 'pie' && chartConfigForm.get('pieDataLabelsEnabled')?.value\"\n                >\n                    <mat-label>Data Label Color</mat-label>\n                    <input matInput type=\"color\" formControlName=\"dataLabelColor\" />\n                </mat-form-field>\n\n                <!-- Enabling data labels for Bar charts-->\n                <mat-checkbox\n                    formControlName=\"barDataLabelsEnabled\"\n                    *ngIf=\"chartConfigForm.get('chartType')?.value === 'bar'\"\n                    class=\"data-labels-checkbox\"\n                >\n                    Enable Data Labels\n                </mat-checkbox>\n\n                <!-- Data Label Color for Bar charts-->\n                <mat-form-field\n                    appearance=\"outline\"\n                    class=\"data-labels-color\"\n                    *ngIf=\"chartConfigForm.get('chartType')?.value === 'bar' && chartConfigForm.get('barDataLabelsEnabled')?.value\"\n                >\n                    <mat-label>Data Label Color</mat-label>\n                    <input matInput type=\"color\" formControlName=\"barDataLabelColor\" />\n                </mat-form-field>\n\n                <!-- Enabling legends checkbox -->\n                <mat-checkbox formControlName=\"showInLegend\" class=\"legends-checkbox\"> Show Legend </mat-checkbox>\n\n                <!-- Legends position dropdown  -->\n                <mat-form-field appearance=\"outline\" class=\"legends-position\" *ngIf=\"chartConfigForm.get('showInLegend')?.value\">\n                    <mat-label>Legend Position</mat-label>\n                    <mat-select formControlName=\"legendPosition\">\n                        <mat-option value=\"top\">Top</mat-option>\n                        <mat-option value=\"bottom\">Bottom</mat-option>\n                        <mat-option value=\"left\">Left</mat-option>\n                        <mat-option value=\"right\">Right</mat-option>\n                    </mat-select>\n                </mat-form-field>\n            </div>\n\n            <div class=\"axis-titles\">\n                <mat-form-field appearance=\"outline\" *ngIf=\"chartConfigForm.get('chartType')?.value === 'bar'\" class=\"x-axis-title\">\n                    <mat-label>X Axis Title</mat-label>\n                    <input matInput formControlName=\"xAxisTitle\" />\n                </mat-form-field>\n\n                <mat-form-field appearance=\"outline\" *ngIf=\"chartConfigForm.get('chartType')?.value === 'bar'\" class=\"y-axis-title\">\n                    <mat-label>Y Axis Title</mat-label>\n                    <input matInput formControlName=\"yAxisTitle\" />\n                </mat-form-field>\n            </div>\n\n            <div class=\"animation-configs\">\n                <mat-form-field appearance=\"outline\" class=\"animations-duration\">\n                    <mat-label>Animation Duration in ms</mat-label>\n                    <input matInput type=\"number\" formControlName=\"animationDuration\" />\n                </mat-form-field>\n\n                <mat-form-field appearance=\"outline\" class=\"animations-style\">\n                    <mat-label>Animation Style</mat-label>\n                    <mat-select formControlName=\"animationEasing\">\n                        <mat-option *ngFor=\"let option of easingOptions\" [value]=\"option\">\n                            {{ option }}\n                        </mat-option>\n                    </mat-select>\n                </mat-form-field>\n            </div>\n        </div>\n\n        <div mat-dialog-actions class=\"dialog-buttons\">\n            <button mat-button color=\"accent\" (click)=\"onCancel()\" class=\"cancel\" type=\"button\">Cancel</button>\n            <button mat-button color=\"primary\" type=\"submit\" class=\"save-customizations\">Save Customizations</button>\n        </div>\n    </form>\n</div>\n", styles: [".dialog-title{display:flex;justify-content:center;align-items:center;text-align:center;width:100%;margin:0;font-weight:700}.full-width,.chart-id{width:100%}.chart-configs{display:flex;justify-content:space-between;width:100%}.chart-configs .chart-library{width:50%;margin-right:8px}.chart-configs .chart-type{width:50%}.title-configs{display:flex;justify-content:space-between;width:100%}.title-configs .title{width:50%;margin-right:8px}.title-configs .title-color{width:50%}.border-configs{display:flex;justify-content:space-between;width:100%}.border-configs .border-thickness{width:50%;margin-right:8px}.border-configs .border-color{width:50%}.rotation-3dchart{display:flex;justify-content:space-between;width:100%}.rotation-3dchart .pie-chart-rotation{width:50%;margin-right:8px}.rotation-3dchart .inner-radius{margin-right:8px;width:50%}.rotation-3dchart .highcharts-3d{width:50%}.orientation-transparentbg{display:flex;justify-content:space-between;width:100%;padding-bottom:2%}.orientation-transparentbg :is(.orientation,.transparent-bg){width:50%;margin-right:8px}.orientation-transparentbg .bgcolor{width:50%}.labels-legends-config{display:flex;justify-content:space-between;width:100%;padding-bottom:2%}.labels-legends-config :is(.data-labels-checkbox,.data-labels-color,.legends-checkbox){width:50%;margin-right:8px}.labels-legends-config .legends-position{width:50%}.axis-titles{display:flex;justify-content:space-between;width:100%}.axis-titles .x-axis-title{width:50%;margin-right:8px}.axis-titles .y-axis-title{width:50%}.animation-configs{display:flex;justify-content:space-between;width:100%}.animation-configs .animations-duration{width:50%;margin-right:8px}.animation-configs .animations-style{width:50%}.dialog-buttons{display:flex;justify-content:flex-end;gap:8px;width:100%}.notification-banner{background-color:#ffecb3;color:#000;padding:10px;display:flex;justify-content:space-between;align-items:center;border-radius:4px;margin-bottom:10px;border:1px solid #ffa000}.notification-banner p{margin:0}.notification-banner button{background:transparent;border:none;cursor:pointer}\n"], dependencies: [{ kind: "directive", type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i1$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$1.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i1$1.MinValidator, selector: "input[type=number][min][formControlName],input[type=number][min][formControl],input[type=number][min][ngModel]", inputs: ["min"] }, { kind: "directive", type: i1$1.MaxValidator, selector: "input[type=number][max][formControlName],input[type=number][max][formControl],input[type=number][max][ngModel]", inputs: ["max"] }, { kind: "directive", type: i1$1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i1$1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "directive", type: i3.MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "directive", type: i3.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "directive", type: i3.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "component", type: i6.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i6.MatLabel, selector: "mat-label" }, { kind: "directive", type: i7.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i8.MatSelect, selector: "mat-select", inputs: ["aria-describedby", "panelClass", "disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator", "placeholder", "required", "multiple", "disableOptionCentering", "compareWith", "value", "aria-label", "aria-labelledby", "errorStateMatcher", "typeaheadDebounceInterval", "sortComparator", "id", "panelWidth"], outputs: ["openedChange", "opened", "closed", "selectionChange", "valueChange"], exportAs: ["matSelect"] }, { kind: "component", type: i9.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "component", type: i10.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "component", type: i10.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "component", type: i11.MatCheckbox, selector: "mat-checkbox", inputs: ["aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "disableRipple", "tabIndex", "color", "disabledInteractive", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { kind: "directive", type: i12.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer", "cdkDragScale"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { kind: "component", type: i13.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: ModifyChartDialogComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-modify-chart-dialog', template: "<div cdkDrag cdkDragRootElement=\".cdk-overlay-pane\">\n    <div class=\"notification-banner\" *ngIf=\"showNotification\">\n        <p>You can move this dialog box by dragging it around!</p>\n        <button mat-icon-button (click)=\"closeNotification()\">\n            <mat-icon>close</mat-icon>\n        </button>\n    </div>\n    <h1 mat-dialog-title class=\"dialog-title\">Modify Chart: {{ chartConfigForm.get('title')?.value || 'Untitled' }}</h1>\n\n    <form [formGroup]=\"chartConfigForm\" (ngSubmit)=\"onSaveChart()\">\n        <div mat-dialog-content>\n            <div class=\"chart-id\">\n                <!-- Chart ID Field -->\n                <mat-form-field appearance=\"outline\" class=\"full-width\">\n                    <mat-label>Chart ID</mat-label>\n                    <input matInput [value]=\"chartId\" readonly />\n                </mat-form-field>\n            </div>\n\n            <div class=\"chart-configs\">\n                <!-- Chart Library Dropdown -->\n                <mat-form-field appearance=\"outline\" class=\"chart-library\">\n                    <mat-label>Chart Library</mat-label>\n                    <mat-select formControlName=\"chartLibrary\">\n                        <mat-option value=\"highcharts\">Highcharts</mat-option>\n                        <mat-option value=\"chartjs\">Chart.js</mat-option>\n                    </mat-select>\n                </mat-form-field>\n\n                <!-- Chart Type Dropdown -->\n                <mat-form-field appearance=\"outline\" class=\"chart-type\">\n                    <mat-label>Chart Type</mat-label>\n                    <mat-select formControlName=\"chartType\">\n                        <mat-option value=\"pie\">Pie</mat-option>\n                        <mat-option value=\"bar\">Bar</mat-option>\n                    </mat-select>\n                </mat-form-field>\n            </div>\n\n            <div class=\"title-configs\">\n                <!-- Chart Title -->\n                <mat-form-field appearance=\"outline\" class=\"title\">\n                    <mat-label>Chart Title</mat-label>\n                    <input matInput formControlName=\"title\" />\n                </mat-form-field>\n\n                <!-- Title Color -->\n                <mat-form-field appearance=\"outline\" class=\"title-color\">\n                    <mat-label>Title Color</mat-label>\n                    <input matInput type=\"color\" formControlName=\"titleColor\" />\n                </mat-form-field>\n            </div>\n\n            <div class=\"border-configs\">\n                <!-- Border thickness-->\n                <mat-form-field appearance=\"outline\" class=\"border-thickness\">\n                    <mat-label>Border Thickness</mat-label>\n                    <input matInput type=\"number\" formControlName=\"borderWidth\" />\n                </mat-form-field>\n\n                <!-- Border Color  -->\n                <mat-form-field appearance=\"outline\" class=\"border-color\">\n                    <mat-label>Border Color</mat-label>\n                    <input matInput type=\"color\" formControlName=\"borderColor\" />\n                </mat-form-field>\n            </div>\n\n            <div class=\"rotation-3dchart\">\n                <!-- Chart rotation  -->\n                <mat-form-field appearance=\"outline\" class=\"pie-chart-rotation\" *ngIf=\"chartConfigForm.get('chartType')?.value === 'pie'\">\n                    <mat-label>Rotation (degrees)</mat-label>\n                    <input matInput type=\"number\" min=\"0\" max=\"360\" formControlName=\"rotation\" />\n                </mat-form-field>\n\n                <mat-form-field appearance=\"outline\" *ngIf=\"chartConfigForm.get('chartType')?.value === 'pie'\" class=\"inner-radius\">\n                    <mat-label>Inner Radius</mat-label>\n                    <input matInput type=\"number\" formControlName=\"innerRadius\" />\n                </mat-form-field>\n\n                <!-- 3D charts for Highcharts library -->\n                <mat-checkbox formControlName=\"enable3D\" class=\"highcharts-3d\" *ngIf=\"chartConfigForm.get('chartLibrary')?.value === 'highcharts'\">\n                    Enable 3D\n                </mat-checkbox>\n            </div>\n\n            <div class=\"orientation-transparentbg\">\n                <mat-form-field appearance=\"outline\" *ngIf=\"chartConfigForm.get('chartType')?.value === 'bar'\" class=\"orientation\">\n                    <mat-label>Orientation</mat-label>\n                    <mat-select id=\"orientation\" formControlName=\"orientation\">\n                        <mat-option value=\"vertical\"> Vertical </mat-option>\n                        <mat-option value=\"horizontal\"> Horizontal </mat-option>\n                    </mat-select>\n                </mat-form-field>\n\n                <mat-checkbox formControlName=\"transparentBackground\" class=\"transparent-bg\"> Transparent Chart Background </mat-checkbox>\n\n                <mat-form-field appearance=\"outline\" class=\"bgcolor\" *ngIf=\"!chartConfigForm.get('transparentBackground')?.value\">\n                    <mat-label>Chart Background Color</mat-label>\n                    <input matInput type=\"color\" formControlName=\"backgroundColor\" />\n                </mat-form-field>\n            </div>\n\n            <div class=\"labels-legends-config\">\n                <!-- Enabling data labels for Pie charts-->\n                <mat-checkbox\n                    formControlName=\"pieDataLabelsEnabled\"\n                    *ngIf=\"chartConfigForm.get('chartType')?.value === 'pie'\"\n                    class=\"data-labels-checkbox\"\n                >\n                    Enable Data Labels\n                </mat-checkbox>\n\n                <!-- Data Label Color for Pie charts-->\n                <mat-form-field\n                    appearance=\"outline\"\n                    class=\"data-labels-color\"\n                    *ngIf=\"chartConfigForm.get('chartType')?.value === 'pie' && chartConfigForm.get('pieDataLabelsEnabled')?.value\"\n                >\n                    <mat-label>Data Label Color</mat-label>\n                    <input matInput type=\"color\" formControlName=\"dataLabelColor\" />\n                </mat-form-field>\n\n                <!-- Enabling data labels for Bar charts-->\n                <mat-checkbox\n                    formControlName=\"barDataLabelsEnabled\"\n                    *ngIf=\"chartConfigForm.get('chartType')?.value === 'bar'\"\n                    class=\"data-labels-checkbox\"\n                >\n                    Enable Data Labels\n                </mat-checkbox>\n\n                <!-- Data Label Color for Bar charts-->\n                <mat-form-field\n                    appearance=\"outline\"\n                    class=\"data-labels-color\"\n                    *ngIf=\"chartConfigForm.get('chartType')?.value === 'bar' && chartConfigForm.get('barDataLabelsEnabled')?.value\"\n                >\n                    <mat-label>Data Label Color</mat-label>\n                    <input matInput type=\"color\" formControlName=\"barDataLabelColor\" />\n                </mat-form-field>\n\n                <!-- Enabling legends checkbox -->\n                <mat-checkbox formControlName=\"showInLegend\" class=\"legends-checkbox\"> Show Legend </mat-checkbox>\n\n                <!-- Legends position dropdown  -->\n                <mat-form-field appearance=\"outline\" class=\"legends-position\" *ngIf=\"chartConfigForm.get('showInLegend')?.value\">\n                    <mat-label>Legend Position</mat-label>\n                    <mat-select formControlName=\"legendPosition\">\n                        <mat-option value=\"top\">Top</mat-option>\n                        <mat-option value=\"bottom\">Bottom</mat-option>\n                        <mat-option value=\"left\">Left</mat-option>\n                        <mat-option value=\"right\">Right</mat-option>\n                    </mat-select>\n                </mat-form-field>\n            </div>\n\n            <div class=\"axis-titles\">\n                <mat-form-field appearance=\"outline\" *ngIf=\"chartConfigForm.get('chartType')?.value === 'bar'\" class=\"x-axis-title\">\n                    <mat-label>X Axis Title</mat-label>\n                    <input matInput formControlName=\"xAxisTitle\" />\n                </mat-form-field>\n\n                <mat-form-field appearance=\"outline\" *ngIf=\"chartConfigForm.get('chartType')?.value === 'bar'\" class=\"y-axis-title\">\n                    <mat-label>Y Axis Title</mat-label>\n                    <input matInput formControlName=\"yAxisTitle\" />\n                </mat-form-field>\n            </div>\n\n            <div class=\"animation-configs\">\n                <mat-form-field appearance=\"outline\" class=\"animations-duration\">\n                    <mat-label>Animation Duration in ms</mat-label>\n                    <input matInput type=\"number\" formControlName=\"animationDuration\" />\n                </mat-form-field>\n\n                <mat-form-field appearance=\"outline\" class=\"animations-style\">\n                    <mat-label>Animation Style</mat-label>\n                    <mat-select formControlName=\"animationEasing\">\n                        <mat-option *ngFor=\"let option of easingOptions\" [value]=\"option\">\n                            {{ option }}\n                        </mat-option>\n                    </mat-select>\n                </mat-form-field>\n            </div>\n        </div>\n\n        <div mat-dialog-actions class=\"dialog-buttons\">\n            <button mat-button color=\"accent\" (click)=\"onCancel()\" class=\"cancel\" type=\"button\">Cancel</button>\n            <button mat-button color=\"primary\" type=\"submit\" class=\"save-customizations\">Save Customizations</button>\n        </div>\n    </form>\n</div>\n", styles: [".dialog-title{display:flex;justify-content:center;align-items:center;text-align:center;width:100%;margin:0;font-weight:700}.full-width,.chart-id{width:100%}.chart-configs{display:flex;justify-content:space-between;width:100%}.chart-configs .chart-library{width:50%;margin-right:8px}.chart-configs .chart-type{width:50%}.title-configs{display:flex;justify-content:space-between;width:100%}.title-configs .title{width:50%;margin-right:8px}.title-configs .title-color{width:50%}.border-configs{display:flex;justify-content:space-between;width:100%}.border-configs .border-thickness{width:50%;margin-right:8px}.border-configs .border-color{width:50%}.rotation-3dchart{display:flex;justify-content:space-between;width:100%}.rotation-3dchart .pie-chart-rotation{width:50%;margin-right:8px}.rotation-3dchart .inner-radius{margin-right:8px;width:50%}.rotation-3dchart .highcharts-3d{width:50%}.orientation-transparentbg{display:flex;justify-content:space-between;width:100%;padding-bottom:2%}.orientation-transparentbg :is(.orientation,.transparent-bg){width:50%;margin-right:8px}.orientation-transparentbg .bgcolor{width:50%}.labels-legends-config{display:flex;justify-content:space-between;width:100%;padding-bottom:2%}.labels-legends-config :is(.data-labels-checkbox,.data-labels-color,.legends-checkbox){width:50%;margin-right:8px}.labels-legends-config .legends-position{width:50%}.axis-titles{display:flex;justify-content:space-between;width:100%}.axis-titles .x-axis-title{width:50%;margin-right:8px}.axis-titles .y-axis-title{width:50%}.animation-configs{display:flex;justify-content:space-between;width:100%}.animation-configs .animations-duration{width:50%;margin-right:8px}.animation-configs .animations-style{width:50%}.dialog-buttons{display:flex;justify-content:flex-end;gap:8px;width:100%}.notification-banner{background-color:#ffecb3;color:#000;padding:10px;display:flex;justify-content:space-between;align-items:center;border-radius:4px;margin-bottom:10px;border:1px solid #ffa000}.notification-banner p{margin:0}.notification-banner button{background:transparent;border:none;cursor:pointer}\n"] }]
        }], ctorParameters: () => [{ type: i1$1.FormBuilder }, { type: AirlineSentimentService }, { type: i3.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }, { type: i4.MatSnackBar }] });

Exporting(Highcharts);
Highcharts3D(Highcharts);
class AirlineSentimentDisplayComponent {
    constructor(sentimentService, dialog) {
        this.sentimentService = sentimentService;
        this.dialog = dialog;
        this.chartId = '';
        this.Highcharts = Highcharts;
        this.chartOptions = {};
        this.enableModifyChartButton = false;
    }
    ngOnInit() {
        // Loads chart if chart ID is provided during initialization
        if (this.chartId) {
            this.loadChart();
        }
    }
    ngOnChanges(changes) {
        // Loads chart if chart ID changes and it's not the first change
        if (changes['chartId'] && !changes['chartId'].firstChange) {
            this.loadChart();
        }
    }
    loadChart() {
        // Fetching chart configuration from the service
        this.sentimentService.getChart(this.chartId).subscribe((config) => {
            // Updating chart options and creating the chart with the fetched configuration
            this.updateChartOptions(config);
            this.createChart();
        }, (error) => {
            console.error('Error fetching chart configuration:', error);
        });
    }
    openModifyChartDialog() {
        this.dialog.open(ModifyChartDialogComponent, {
            width: '600px',
            data: this.chartId,
        });
    }
    updateChartOptions(config) {
        if (!config) {
            return; // if no configuration is provided
        }
        // configuration properties with default values
        const { chartType, title, titleColor, backgroundColor, categories = [], data = [], colors = [], pieColors = [], legends = [], legend, tooltip, xAxisTitle, yAxisTitle, stacking, pieDataLabelsEnabled, barDataLabelsEnabled, showInLegend, innerRadius, explode = [], shadow = false, rotation = 0, labelPosition = 'outside', highchartsOptions = {}, legendPosition = 'bottom', orientation = 'vertical', borderColor, borderWidth, borderDash = 'solid', dataLabelColor, barDataLabelColor, stickTogether = false, enable3D = false, enableModifyChartButton = false, animationDuration = 5000, animationEasing = 'easeOutBounce' } = config;
        const options3d = enable3D
            ? chartType === 'pie'
                ? {
                    enabled: true,
                    alpha: 45,
                    beta: 20,
                    depth: 45,
                    viewDistance: 25,
                }
                : {
                    enabled: true,
                    alpha: 15,
                    beta: 15,
                    depth: 50,
                    viewDistance: 25,
                }
            : {};
        const defaultMargin = 80;
        // Configuring legend options
        const legendOptions = {
            enabled: showInLegend,
            layout: legendPosition === 'top' || legendPosition === 'bottom' ? 'horizontal' : 'vertical',
            align: legendPosition === 'left' ? 'left' : legendPosition === 'right' ? 'right' : 'center',
            verticalAlign: legendPosition === 'top' ? 'top' : legendPosition === 'bottom' ? 'bottom' : 'middle',
            floating: legendPosition === 'left' || legendPosition === 'right',
            x: legendPosition === 'left' ? -20 : legendPosition === 'right' ? 20 : 0,
            y: legendPosition === 'top' ? -20 : legendPosition === 'bottom' ? 20 : 0,
            backgroundColor: 'transparent',
            borderWidth: 0,
            shadow: false,
            labelFormatter: function () {
                return `<b>${legends[this.index] || this.name}</b>`;
            },
        };
        // Configuring chart margins based on legend position
        const chartMargin = {
            left: legendPosition === 'left' ? defaultMargin : undefined,
            right: legendPosition === 'right' ? defaultMargin : undefined,
            top: legendPosition === 'top' ? defaultMargin : undefined,
            bottom: legendPosition === 'bottom' ? defaultMargin : undefined,
        };
        // Adjusting margin based on legend dimensions
        if (legendPosition === 'top' || legendPosition === 'bottom') {
            chartMargin.top = legendPosition === 'top' ? defaultMargin : undefined;
            chartMargin.bottom = legendPosition === 'bottom' ? defaultMargin + 20 : undefined;
        }
        else if (legendPosition === 'left' || legendPosition === 'right') {
            chartMargin.left = legendPosition === 'left' ? defaultMargin + 65 : undefined;
            chartMargin.right = legendPosition === 'right' ? defaultMargin + 40 : undefined;
        }
        this.enableModifyChartButton = enableModifyChartButton;
        // Defining chart options based on configuration
        this.chartOptions = {
            chart: {
                type: chartType === 'pie' ? 'pie' : orientation === 'horizontal' ? 'bar' : 'column',
                backgroundColor: backgroundColor || 'transparent',
                options3d: options3d,
                animation: {
                    duration: animationDuration,
                    easing: "easeOutBounce"
                },
                marginLeft: chartMargin.left,
                marginRight: chartMargin.right,
                marginTop: chartMargin.top,
                marginBottom: chartMargin.bottom,
            },
            title: {
                text: title,
                style: {
                    color: titleColor,
                },
            },
            xAxis: {
                categories: chartType === 'column' && categories.length
                    ? categories.map((category, index) => legends[index] || category)
                    : categories,
                title: {
                    text: xAxisTitle,
                },
                labels: {
                    rotation: orientation === 'horizontal' ? -45 : 0,
                },
                gridLineWidth: 0,
                lineWidth: 1,
                lineColor: '#E5E5E5',
            },
            yAxis: {
                title: {
                    text: yAxisTitle,
                },
                gridLineWidth: 0,
                lineWidth: 1,
                lineColor: '#E5E5E5',
            },
            series: chartType === 'pie'
                ? [
                    {
                        type: chartType,
                        name: title,
                        data: data.map((value, index) => ({
                            name: legends[index] || categories[index],
                            y: value,
                            color: pieColors[index],
                            sliced: explode.includes(index),
                            shadow: shadow,
                            animation: {
                                duration: animationDuration,
                                easing: "easeOutBounce"
                            },
                        })),
                    },
                ]
                : [
                    {
                        type: 'column',
                        name: 'Sentiments',
                        data: data.map((value, index) => ({
                            name: legends[index] || categories[index],
                            y: value,
                            color: colors[index],
                            animation: {
                                duration: animationDuration,
                                easing: "easeOutBounce"
                            },
                        })),
                        dataLabels: {
                            enabled: barDataLabelsEnabled,
                            formatter: function () {
                                return legends[this.point.index] || categories[this.point.index];
                            },
                            color: barDataLabelColor,
                        },
                        plotOptions: {
                            bar: {
                                depth: enable3D ? 25 : undefined,
                                dataLabels: {
                                    enabled: barDataLabelsEnabled,
                                    color: barDataLabelColor,
                                },
                                animation: {
                                    duration: animationDuration,
                                    easing: "easeOutBounce"
                                },
                                horizontal: orientation === 'horizontal',
                                borderColor: borderColor,
                                borderWidth: borderWidth,
                                borderDashStyle: borderDash,
                                pointPadding: stickTogether ? 0 : 0.1,
                                groupPadding: stickTogether ? 0 : 0.2,
                            },
                            column: {
                                depth: enable3D ? 25 : undefined,
                                dataLabels: {
                                    enabled: true,
                                    color: dataLabelColor,
                                },
                                animation: {
                                    duration: animationDuration,
                                    easing: "easeOutBounce"
                                },
                                borderColor: borderColor,
                                borderWidth: borderWidth,
                                borderDashStyle: borderDash,
                            },
                        },
                    },
                ],
            legend: legendOptions,
            tooltip: tooltip,
            plotOptions: {
                pie: {
                    innerSize: innerRadius ? `${innerRadius}%` : '0',
                    borderColor: borderColor,
                    borderWidth: borderWidth,
                    borderDashStyle: borderDash,
                    depth: enable3D ? 45 : undefined,
                    dataLabels: {
                        enabled: pieDataLabelsEnabled,
                        align: labelPosition === 'inside' ? 'center' : 'outside',
                        color: dataLabelColor,
                    },
                    animation: {
                        duration: animationDuration,
                        easing: "easeOutBounce"
                    },
                    showInLegend: showInLegend,
                    startAngle: rotation,
                },
                column: {
                    dataLabels: {
                        enabled: barDataLabelsEnabled,
                        formatter: function () {
                            return legends[this.point.index] || categories[this.point.index];
                        },
                        color: barDataLabelColor,
                    },
                    animation: {
                        duration: animationDuration,
                        easing: "easeOutBounce"
                    },
                    horizontal: orientation === 'horizontal',
                    borderColor: borderColor,
                    borderWidth: borderWidth,
                    borderDashStyle: borderDash,
                    pointPadding: stickTogether ? 0 : 0.1,
                    groupPadding: stickTogether ? 0 : 0.2,
                },
                series: {
                    stacking: stacking,
                },
            },
            exporting: {
                enabled: false,
            },
            credits: {
                enabled: false,
            },
            ...highchartsOptions,
        };
    }
    createChart() {
        // Creating and rendering the chart in the container element
        const containerElement = document.getElementById('sentiment-chart-container');
        if (containerElement) {
            Highcharts.chart(containerElement, this.chartOptions);
        }
        else {
            // Handling error if container element is not found
            console.error('Error: Container element not found.');
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: AirlineSentimentDisplayComponent, deps: [{ token: AirlineSentimentService }, { token: i3.MatDialog }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.5", type: AirlineSentimentDisplayComponent, selector: "sentiment-component", inputs: { chartId: "chartId" }, usesOnChanges: true, ngImport: i0, template: "<div class=\"piechart\">\n  <div id=\"sentiment-chart-container\" style=\"height: 750px; width: 100%\"></div>\n</div>\n\n<!-- <i\n  class=\"fa-regular fa-pen-to-square\"\n  *ngIf=\"enableModifyChartButton\"\n  matTooltip=\"Modify Chart\"\n  matTooltipPosition=\"left\"\n  matTooltipClass=\"custom-tooltip\"\n  (click)=\"openModifyChartDialog()\"\n> -->\n<button (click)=\"openModifyChartDialog()\" class=\"modify-button\">Modify</button>\n", styles: ["#sentiment-chart-container{height:750px;width:100%}.modify-button{position:absolute;font-size:1rem;top:10px;right:10px;z-index:10;color:#b726a2;cursor:pointer}.custom-tooltip{background-color:#b726a2;color:#fff;font-size:14px}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: AirlineSentimentDisplayComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sentiment-component', template: "<div class=\"piechart\">\n  <div id=\"sentiment-chart-container\" style=\"height: 750px; width: 100%\"></div>\n</div>\n\n<!-- <i\n  class=\"fa-regular fa-pen-to-square\"\n  *ngIf=\"enableModifyChartButton\"\n  matTooltip=\"Modify Chart\"\n  matTooltipPosition=\"left\"\n  matTooltipClass=\"custom-tooltip\"\n  (click)=\"openModifyChartDialog()\"\n> -->\n<button (click)=\"openModifyChartDialog()\" class=\"modify-button\">Modify</button>\n", styles: ["#sentiment-chart-container{height:750px;width:100%}.modify-button{position:absolute;font-size:1rem;top:10px;right:10px;z-index:10;color:#b726a2;cursor:pointer}.custom-tooltip{background-color:#b726a2;color:#fff;font-size:14px}\n"] }]
        }], ctorParameters: () => [{ type: AirlineSentimentService }, { type: i3.MatDialog }], propDecorators: { chartId: [{
                type: Input
            }] } });

class ChartJsDisplayComponent {
    constructor(sentimentService, dialog) {
        this.sentimentService = sentimentService;
        this.dialog = dialog;
        this.chartId = '';
        this.enableModifyChartButton = false;
        Chart.register(...registerables, ChartDataLabels);
    }
    ngOnInit() {
        // Loading chart data if chartId is provided
        if (this.chartId) {
            this.loadChart();
        }
    }
    ngOnChanges(changes) {
        // Reloading chart if chartId changes and it's not the first change
        if (changes['chartId'] && !changes['chartId'].firstChange) {
            this.loadChart();
        }
    }
    // loadChart(): void {
    //     // Fetching chart configuration from the service
    //     this.sentimentService.getChart(this.chartId).subscribe(
    //         (config: any) => {
    //             this.chartConfig = config; // Save the configuration
    //             this.createChart(); // Create the chart with the new configuration
    //         },
    //         (error: any) => {
    //             console.error('Error fetching chart configuration:', error);
    //         }
    //     );
    // }
    openModifyChartDialog() {
        this.dialog.open(ModifyChartDialogComponent, {
            width: '600px',
            data: this.chartId
        });
    }
    loadChart() {
        // Fetching chart configuration from the service
        this.sentimentService.getChart(this.chartId).subscribe({
            next: (config) => {
                this.chartConfig = config; // Saving the configurationa
                this.enableModifyChartButton = config.enableModifyChartButton ?? false;
                this.createChart(); // Creating the chart with the new configurations
            },
            error: (error) => {
                console.error('Error fetching chart configuration:', error);
            },
        });
    }
    createChart() {
        const ctx = document.getElementById('chartCanvas');
        if (!ctx)
            return;
        if (this.chart) {
            this.chart.destroy();
        }
        ctx.width = this.chartConfig.width || 600;
        ctx.height = this.chartConfig.height || 600;
        // Defining chart options
        const chartOptions = {
            plugins: {
                legend: {
                    display: this.chartConfig.showInLegend || false,
                    position: this.chartConfig.legendPosition || 'top',
                    labels: {
                        generateLabels: (chart) => {
                            // Customizing legend labels
                            const originalLabels = chart.data.labels;
                            return originalLabels.map((label, index) => ({
                                text: this.chartConfig.legends ? this.chartConfig.legends[index] : label,
                                fillStyle: chart.data.datasets[0].backgroundColor[index],
                                strokeStyle: chart.data.datasets[0].borderColor[index],
                            }));
                        },
                        usePointStyle: true,
                        pointStyle: 'circle',
                        font: {
                            weight: 'bold',
                            size: 12,
                            family: 'Arial, sans-serif',
                        },
                    },
                    padding: {
                        top: 10,
                        bottom: 10,
                    },
                    maxHeight: 60,
                    maxWidth: 200,
                },
                tooltip: {
                    enabled: this.chartConfig.tooltip?.enabled || false,
                },
                title: {
                    display: true,
                    text: this.chartConfig.title || '',
                    color: this.chartConfig.titleColor || '#000000',
                    font: {
                        size: 20,
                        family: 'Arial, sans-serif',
                    },
                    padding: {
                        top: 1,
                        bottom: 30,
                    },
                },
                datalabels: {
                    display: this.chartConfig.chartType === 'pie' ? this.chartConfig.pieDataLabelsEnabled : this.chartConfig.barDataLabelsEnabled,
                    color: this.chartConfig.dataLabelColor || '#000000',
                    anchor: 'end',
                    align: 'end',
                    offset: 10,
                    formatter: (value, context) => {
                        // Formatting data labels
                        const label = this.chartConfig.legends
                            ? this.chartConfig.legends[context.dataIndex]
                            : context.chart.data.labels[context.dataIndex];
                        return `${label}`;
                    },
                    font: {
                        weight: 'bold',
                        size: 12,
                        family: 'Arial, sans-serif',
                    },
                    clip: false,
                    overflow: true,
                },
            },
            layout: {
                padding: {
                    bottom: 40,
                    left: 40,
                    right: 40,
                    top: 40,
                },
            },
            scales: {},
            backgroundColor: this.chartConfig.backgroundColor || '#FFFFFF',
            animation: {
                duration: this.chartConfig.animationDuration || 4000, // Default 1-second animation if not set
                easing: this.chartConfig.animationEasing || 'easeInOutElastic', // Default easing function
            },
        };
        let datasets = [];
        if (this.chartConfig.chartType === 'pie') {
            // Configuring pie charts
            chartOptions.cutout = `${this.chartConfig.innerRadius || 0}%`; // Inner radius for doughnut charts
            datasets = [
                {
                    label: this.chartConfig.title,
                    data: this.chartConfig.data,
                    backgroundColor: this.chartConfig.pieColors || [],
                    borderColor: this.chartConfig.borderColor || '',
                    borderWidth: this.chartConfig.borderWidth || 0,
                },
            ];
            chartOptions.rotation = this.chartConfig.rotation || 0;
        }
        else if (this.chartConfig.chartType === 'bar') {
            // Configuring bar charts
            const isHorizontal = this.chartConfig.orientation === 'horizontal';
            chartOptions.scales = {
                x: {
                    title: {
                        display: true,
                        text: isHorizontal ? this.chartConfig.yAxisTitle : this.chartConfig.xAxisTitle, // Swapping titles if horizontal
                    },
                    grid: {
                        display: false,
                    },
                    stacked: this.chartConfig.stickTogether || false,
                },
                y: {
                    title: {
                        display: true,
                        text: isHorizontal ? this.chartConfig.xAxisTitle : this.chartConfig.yAxisTitle, // Swapping titles if horizontal
                    },
                    grid: {
                        display: false,
                    },
                    stacked: this.chartConfig.stickTogether || false,
                },
            };
            if (isHorizontal) {
                chartOptions.indexAxis = 'y'; // for horizontal bar charts
            }
            datasets = [
                {
                    label: this.chartConfig.title,
                    data: this.chartConfig.data,
                    backgroundColor: this.chartConfig.colors || [],
                    borderColor: this.chartConfig.borderColor || '',
                    borderWidth: this.chartConfig.borderWidth || 0,
                    borderDash: this.chartConfig.borderDashPattern || [],
                },
            ];
            chartOptions.plugins.datalabels = {
                display: this.chartConfig.barDataLabelsEnabled || false,
                color: this.chartConfig.barDataLabelColor || this.chartConfig.dataLabelColor || '#000000',
                anchor: 'end',
                align: 'end',
                offset: 10,
                formatter: (value, context) => {
                    const label = this.chartConfig.legends
                        ? this.chartConfig.legends[context.dataIndex]
                        : context.chart.data.labels[context.dataIndex];
                    return `${label}`;
                },
                font: {
                    weight: 'bold',
                    size: 12,
                    family: 'Arial, sans-serif',
                },
                clip: false,
                overflow: true,
            };
        }
        // Initializing the Chart.js chart with the configured options
        this.chart = new Chart(ctx, {
            type: this.chartConfig.chartType === 'pie' ? 'doughnut' : this.chartConfig.chartType,
            data: {
                labels: this.chartConfig.categories.map((category, index) => this.chartConfig.legends ? this.chartConfig.legends[index] : category),
                datasets: datasets,
            },
            options: {
                ...chartOptions,
                plugins: {
                    ...chartOptions.plugins,
                    legend: {
                        ...chartOptions.plugins.legend,
                        position: this.chartConfig.legendPosition,
                    },
                    datalabels: {
                        ...chartOptions.plugins.datalabels,
                    },
                },
            },
        });
        // background color of the canvas
        ctx.style.backgroundColor = this.chartConfig.backgroundColor || 'transparent';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: ChartJsDisplayComponent, deps: [{ token: AirlineSentimentService }, { token: i3.MatDialog }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.5", type: ChartJsDisplayComponent, selector: "sentiment-component-chartjs", inputs: { chartId: "chartId" }, usesOnChanges: true, ngImport: i0, template: "<div class=\"chart-container\">\n  <canvas id=\"chartCanvas\"></canvas>\n</div>\n\n<!-- <i\n  class=\"fa-regular fa-pen-to-square\"\n  *ngIf=\"enableModifyChartButton\"\n  matTooltip=\"Modify Chart\"\n  matTooltipPosition=\"left\"\n  matTooltipClass=\"custom-tooltip\"\n  (click)=\"openModifyChartDialog()\">\n  </i>     -->\n<button (click)=\"openModifyChartDialog()\" class=\"modify-button\">Modify</button>\n", styles: [".modify-button{position:absolute;font-size:1rem;top:10px;right:10px;z-index:10;color:#b726a2;cursor:pointer}.custom-tooltip{background-color:#b726a2;color:#fff;font-size:14px}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: ChartJsDisplayComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sentiment-component-chartjs', template: "<div class=\"chart-container\">\n  <canvas id=\"chartCanvas\"></canvas>\n</div>\n\n<!-- <i\n  class=\"fa-regular fa-pen-to-square\"\n  *ngIf=\"enableModifyChartButton\"\n  matTooltip=\"Modify Chart\"\n  matTooltipPosition=\"left\"\n  matTooltipClass=\"custom-tooltip\"\n  (click)=\"openModifyChartDialog()\">\n  </i>     -->\n<button (click)=\"openModifyChartDialog()\" class=\"modify-button\">Modify</button>\n", styles: [".modify-button{position:absolute;font-size:1rem;top:10px;right:10px;z-index:10;color:#b726a2;cursor:pointer}.custom-tooltip{background-color:#b726a2;color:#fff;font-size:14px}\n"] }]
        }], ctorParameters: () => [{ type: AirlineSentimentService }, { type: i3.MatDialog }], propDecorators: { chartId: [{
                type: Input
            }] } });

class CustomComponentLibraryModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: CustomComponentLibraryModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.5", ngImport: i0, type: CustomComponentLibraryModule, declarations: [CustomComponentLibraryComponent, AirlineSentimentDisplayComponent, ChartJsDisplayComponent, ModifyChartDialogComponent], imports: [CommonModule,
            HttpClientModule,
            FormsModule,
            ReactiveFormsModule,
            MatDialogModule,
            MatFormFieldModule,
            MatInputModule,
            MatSelectModule,
            MatButtonModule,
            MatCheckboxModule,
            MatTooltipModule,
            DragDropModule,
            MatIconModule], exports: [CustomComponentLibraryComponent, AirlineSentimentDisplayComponent, ChartJsDisplayComponent, ModifyChartDialogComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: CustomComponentLibraryModule, imports: [CommonModule,
            HttpClientModule,
            FormsModule,
            ReactiveFormsModule,
            MatDialogModule,
            MatFormFieldModule,
            MatInputModule,
            MatSelectModule,
            MatButtonModule,
            MatCheckboxModule,
            MatTooltipModule,
            DragDropModule,
            MatIconModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.5", ngImport: i0, type: CustomComponentLibraryModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CustomComponentLibraryComponent, AirlineSentimentDisplayComponent, ChartJsDisplayComponent, ModifyChartDialogComponent],
                    imports: [
                        CommonModule,
                        HttpClientModule,
                        FormsModule,
                        ReactiveFormsModule,
                        MatDialogModule,
                        MatFormFieldModule,
                        MatInputModule,
                        MatSelectModule,
                        MatButtonModule,
                        MatCheckboxModule,
                        MatTooltipModule,
                        DragDropModule,
                        MatIconModule,
                    ],
                    exports: [CustomComponentLibraryComponent, AirlineSentimentDisplayComponent, ChartJsDisplayComponent, ModifyChartDialogComponent],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { AirlineSentimentDisplayComponent, AirlineSentimentService, ChartJsDisplayComponent, CustomComponentLibraryComponent, CustomComponentLibraryModule, CustomComponentLibraryService, ModifyChartDialogComponent };
//# sourceMappingURL=ngx-custom-component-library.mjs.map
