export interface ChartConfig {
    chartType: 'bar' | 'pie';
    title: string;
    titleColor?: string;
    categories: string[];
    data: number[];
    orientation?: 'vertical' | 'horizontal';
    colors?: string[];
    pieColors?: string[];
    legend?: {
        enabled: boolean;
    };
    tooltip?: {
        enabled: boolean;
    };
    xAxisTitle?: string;
    yAxisTitle?: string;
    stacking?: string;
    pieDataLabelsEnabled?: boolean;
    barDataLabelsEnabled?: boolean;
    showInLegend?: boolean;
    innerRadius?: number;
    highchartsOptions?: Highcharts.Options;
    legendPosition?: 'top' | 'bottom' | 'left' | 'right';
    backgroundColor?: string;
    explode?: number[];
    shadow?: boolean;
    rotation?: number;
    labelPosition?: 'inside' | 'outside';
    borderWidth?: number;
    borderColor?: string;
    dataLabelColor?: string;
    barDataLabelColor?: string;
    chartLibrary?: 'highcharts' | 'chartjs';
    stickTogether?: boolean;
    enable3D?: boolean;
    animationDuration?: number;
    animationEasing?: String;
    enableModifyChartButton?: boolean;
    transparentBackground?: boolean;
}
